/*  Mudlib Configuration File */

#ifndef CONFIG_H
#define CONFIG_H


/*
 * The Heaven7 mudlib will autoconfigure for the following drivers:
 *	amylaar drivers - at least to 3.2.1@35
 *	3.1.2 drivers - except Olav Kolbu's msdos ok312 driver
 *      MudOS 0.9.1.93 Olav's Kolbu's msdos Mudos driver
 *
 *	Prefered driver mode is COMPAT
 *                              ^^^^^^
 */                                                                  

/*
 * Define OK312 if you are going to use the old msdos 3.1.2 driver
 *
 * I have ported amylaar drivers to msdos, so this is essentially 
 * superseded - Zilanthius
 */
  
/* #define OK312       /* ok312 msdos driver           */



/***********************************************************************/
/* Auto-config some stuff */

#ifndef COMPAT_FLAG
#define NATIVE_MODE
#define UID_ROOT     "Root"
#define UID_BACKBONE "Backbone"
#define UID_TYPE string
#else
#define UID_ROOT     1
#define UID_TYPE int
#endif /* COMPAT_FLAG */


#ifdef MUDOS       

#define MUDOS_DR
#define HAVE_WIZLIST 2

#else /* !MUDOS */

#ifdef __VERSION__

#if __VERSION__ > "03.02.1@0" && __VERSION__ < "03.02.1@999" 
#define AMYLAAR321
#endif

#if __VERSION__ > "03.02@0" && __VERSION__ < "03.02@999"
#define AMYLAAR
#endif

#ifdef AMYLAAR321
#define AMYLAAR
#endif

#else /* !__VERSION__ */

#if !defined(OK312)
#define 312DR
#endif /* !OK312 */

#define HAVE_WIZLIST 1

#endif /* !__VERSION__ */

#endif /* !MUDOS */


/***********************************************************************/ /*
Driver Configuration */

#undef VERSION
#define DEBUG_LOG   "/"+ query_host_name() +".debug.log"
#define MAIN_LOG    "/log/log"


     /*************************************/
     /* configure for MSDOS 3.1.2 version */
     /*************************************/

#if defined(OK312)          

#define 312MASTER   
#define MSDOS
#define OLD_EXPLODE

#ifdef NATIVE_MODE
#define VERSION "3.1.2 MS-DOS Native"
#else
#define VERSION "3.1.2 MS-DOS Compat"
#endif
#undef DEBUG_LOG
#define DEBUG_LOG              "/debug.log"

#endif /* OK312 */


     /***********************/
     /* configure for 3.1.2 */
     /***********************/

#if defined(312DR)            

#define 312MASTER
#define OLD_EXPLODE

#ifdef NATIVE_MODE
#define VERSION "3.1.2 Native"
#else
#define VERSION "3.1.2 Compat"
#endif

#endif /* 3.1.2 */


     /********************************/
     /* configure for 0.9.1.93 MUDOS */
     /********************************/
     
#if defined(MUDOS_DR)         

#ifdef MSDOS
#define VERSION "OK09193c MS-DOS mudOS"
#undef DEBUG_LOG
#define DEBUG_LOG              "/log/debug.log"
#else
#define VERSION "MudOS"
#endif

#endif /* ok09193 msdos mudos */


     /********************************/
     /* configure for Amylaar Driver */
     /********************************/
     
#if defined(AMYLAAR)

#if defined(AMYLAAR321) || __VERSION__ > "03.02@156"
#define HAVE_WIZLIST 0
#else
#define HAVE_WIZLIST 1
#endif 

#ifdef NATIVE_MODE
#define VERSION "Amylaar "+ __VERSION__ +" Native"
#else
#define VERSION "Amylaar "+ __VERSION__ +" Compat"
#endif

#ifdef MSDOS
#undef DEBUG_LOG
#define DEBUG_LOG "/debug.log"
#endif /* MSDOS */

#endif /* AMYLAAR */

/*****************************************************************/ 

#ifdef MSDOS
#define DEAD_ED      "dead_ed"
#define ED_SAVE      "_edrc"
#endif

#ifndef DEAD_ED
#define DEAD_ED      ".dead_ed_files"
#endif

#ifndef ED_SAVE
#define ED_SAVE      ".edrc"
#endif


#endif /* CONFIG_H */
