/*  Mudlib Configuration File */

#ifndef MUDLIB_H
#define MUDLIB_H

#include "/include/config.h"

#define MUD_VERSION "v3.0"  /* Version of Heaven7 mudlib */ 


#undef MUD_NAME
#define MUD_NAME        "Heaven7"
#define INTERMUD_NAME   "H7"

/*
 * Directories
 */
 
#define DOMAIN_DIR             "/d/"
#define WIZARD_DIR             "/players/"


/*
 * Central Mudlib Objects
 */

#if !defined(NATIVE_MODE)
#define MASTER                 "obj/master"
#else
#define MASTER                 "secure/master"
#endif

#define SIMUL_EFUN             "secure/sim_ef_1"
#define SPARE_SIMUL_EFUN_FILE  "secure/sim_ef_2"  /* Not used in MUDos */ 
#define BASE                   "inherit/base/base_obj"
#define SECURITY_FILE          "secure/security"
#define ACTIONS                "inherit/base/actions"
#define PLAYER                 "obj/player"
#define WIZARD                 "obj/wizard"


/*
 * General Mudlib Objects
 * please keep it in alphabetical order?
 */

#define ACTIONS_BIN	   "/inherit/base/accbin"
#define ARMOUR            "inherit/armour"
#define BANK              "inherit/std_bank"
#define BULLETIN          "obj/bulletin"
#define BULLETIN_BOARD     BULLETIN
#define CHANNEL_D	  "/function/channel"
#define CHURCH		  "room/city/cleric/hall4"
#define CLOTHING	   "inherit/clothing"
#define CONTAINER         "inherit/contain"
#define DRINK             "inherit/drink"
#define FOOD              "inherit/food"
#define GUILD             "inherit/guild"
#define INNER             "room/city/creator/inner1"
#define LIVING            "inherit/base/living"
#define MAGIC_ARMOUR      "inherit/m_armour"
#define MAGIC_POTION      "objects/potion"
#define MAGIC_SCROLL      "objects/scroll"
#define MAGIC_WAND        "objects/wand"
#define MAGIC_WEAPON      "inherit/m_weapon"
#define MAIL_DIR          "room/post/"
#define MONEY             "obj/money"
#define MONSTER           "inherit/monster"
#define MORE_OB           "obj/more"
#define PASTE_DIR         "open/paste"
#define POST_OFFICE       "room/city/post"
#define PUB               "inherit/std_pub"
#define ROOM              "inherit/room2"
#define SCROLL		    MAGIC_SCROLL
#define SHUTD             "obj/shut"
#define SIGN              "inherit/sign"
#define STORE             "inherit/store"
#define TARX              "secure/tarx"
#define TREASURE          "inherit/treasure"
#define UNDEAD            "inherit/undead"
#define VOID              "room/void"
#define WAND              "inherit/wand"
#define WEAPON            "inherit/weapon"


/*
 * If the following are not defined, the relevant object will be 
 * removed from usage in player objects.                        
 */    

#define PARTY_DAEMON      "obj/party/party_d"
#define MAIL_FIELD_LOADER "obj/mail_ldr"
#define MAILER            "obj/mail_rdr"
#define EDITOR            "obj/editor"
#define PAGER             "obj/pager"
#define DEBUG             "secure/debug"
#define SOUL              "obj/soul"
#define SOUL_FUNC_FILE    "/obj/soul_fcn.c"
#define QUEST_ROOM        "/room/registry/quest_rm"


/*
 * Intermud
 */

#if defined(AMYLAAR) && !defined(MSDOS)
#define INTERMUD          1
#define UDP_CMD_DIR       "secure/UDP_CMD_DIR/"
#define INETD             "secure/inetd"
#endif


/******************************************************************/ 
/* a shorter time string */

#define DATE(T) ctime(T)[4..10]+((ctime(T)[20..23] == ctime(time())[20..23])\
  ? ctime(T)[11..15] : ctime(T)[20..23])



/*******************************************************************/
/* Money things. The ratio of types */

#define PLATINUM 5000
#define GOLD     1000
#define SILVER   100
#define COPPER   1


/********************************************************************/
/* misc items */
#define BS(n)	"\n"
#endif /* MUDLIB_H */
