#include <mudlib.h>
inherit ROOM;

object prince, sword;

void reset(status arg) {
  if (!present("radagast")) {
    /* Moria Definition */

    prince = clone_object (MONSTER);
    prince->set_name("radagast");
    prince->set_alias("prince");
    prince->set_short("Radagast the Evil Prince");
    prince->set_long( 
	"This is the Evil Minotaur Prince. He is very evil and very angry\n"+
	"with you for waking him up!!\n");
    prince->set_level(13);
    prince->set_gender(1);
    prince->set_race("minotaur");
    prince->set_ac(10);
    prince->set_hp(260);
    prince->set_max_hp(260);
    prince->set_wc(17);
    prince->set_al(300);
    prince->add_money(250);
    move_object(prince, this_object());
    
    /* Weapon definition */
  
    sword = clone_object(WEAPON);
    sword->set_name("sword");
    sword->set_short("Evil Prince's Sword");
    sword->set_long( 
		"This sword was taken from the Evil Minotaur Prince.\n"+
		"He was probably killed when someone woke him up!\n");
    sword->set_length(54);
    sword->set_weight(5);
    sword->set_wc(16);
    sword->set_type("cleave");
    sword->set_value(3500);
    move_object(sword, prince);
    
    prince->init_command("wield sword");
  }
  
  if(!arg) {
    set_short("Evil Prince's Room");
    set_long(
"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n"+
"You have stumbled into the evil prince's room. This is where he sleeps\n"+
"and hides from those he has stolen from. This room is has been neglected\n"+
"compared to the other sections of the castle. There is also a bed here.\n"+
"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
    set_weather(2,2,0);
    set_items(({
      "lever",  "Perhaps if you were to PULL it...",
      "bed",  "This is where the prince sleeps. It provides a good place to hide",
    }));
  }
}


void init() { 
  ::init();
  add_action("pull", "pull"); 
  add_action("jump", "jump");
}

status pull(string lev) {
  if (lev == "lever") {
    if (!present("prince")) {
      say (this_player()->query_name()+ "pulls the lever and is returned to the\n"+
	   "castle.\n");
      move_player(  "players/sarak/minotaur/castle1");
      write ("You pull the lever. A grinding noise comes from within the walls as\n"+
	     "they begin to move! The whole wall turns around taking you with it!!\n"+
	     "You are thrown to the ground as the wall stops abruptly to turn back\n"+
	     "to it's original position.\n");
      return 1;
    }
    else {
      write  ("The prince will not let you leave!!\n");
      return 1;
    }
  }
  return 0;
}
    
    
status jump(string jmp) {
  if ((jmp == "under bed") || (jmp == "under the bed")) {
    write ("You poke the prince in the eyes and jump under his bed! When the prince\n"+
	   "regains his sight, he sees you are gone and goes back to bed. You wander\n"+
	   "how long you should wait until you come out...\n");
    say (this_player()->query_name()+ "pokes the prince in the eyes and jumps under the bed!\n");
    move_player("players/sarak/minotaur/under_bed");
    return 1;
  }
  return 0;
}
