inherit "inherit/room2";

#define NAME "relgar"

void init() {
    ::init();
    set_no_fight(1);
    set_no_summon(1);
    add_action("time_set","time");
} /* End of init */

reset (arg) {
    if (arg) return;

    set_short( "Relgar's Workroom");
    set_long(
      "\tYou've entered the crypt of Relgar the Dark Elven Lich. There are\n"+
      "cobwebs and dust in every corner of this room. The air in here is musty\n"+
      "and very still. You can hear everything in this room in this room because\n"+
      "it is so deathly quiet in here. You think you can hear the dust settling.\n"+
      "In the middle of the room is a table with what looks like a rotting and \n"+
      "decaying corpse. On the corpses chest is a shield and a sword underneath\n"+
      "the shield. All around the room are sculpted faces of what look like "+
      "demons.\nYou start to feel the tingle of fear running up your spine. "+
      "Perhaps you\nshould leave this place.\n");
    set_weather(5, 1, 2);
    set_exits(({
	"/room/city/square.c","square",
	"/room/city/creator/inner1","cboard",
	"/room/city/mage/guild","mage",
	"/room/city/cleric/hall4","cleric",
	"/room/city/cleric/paladin","paladin",
	"/room/city/thief/guild","thief",
	"/room/city/shop/shop","shop",
	"/room/city/arena/guild","fighter",
	"/room/city/t_hall2","nboard",
      }));
    custom_exits="";
    set_items(({ "cobwebs","The cobwebs hang in the upper corners of the room "+
	"where the walls meet the\nceiling. It is fairly obvious that noone has seen "+
	"the need to dust for many\ncenturies.\n",
	"dust","This fine dust covers everything in the room with a fine layer. It "+
	"appears\nto be undisturbed except for the table which is free from any dust "+
	"or\ncobwebs.\n",
	"faces","The faces of every demon you've ever heard of potrude, at even "+
	"intervals, from\nthe walls around the room. They gaze stonily and appear "+
	"to be jeering\nat you from their perches high above the floor. As you gaze "+
	"at them, you think\nyou see small fires in the eyes of one of them. You look "+
	"closer and not seeing \nanything you decide it was your imagination.\n",
	"table","This large stone table has high relief carvings of what look like "+
	"demon heads\nand minions of evil dancing around half eaten corpses of their "+
	"prey. It is free\nfrom any dust or dirt whatsoever. You wonder why the table "+
	"is the only item\nspared by the dust of ages.\n",
	"shield","This crested shield sports the emblem of an eagle in mid-flight with"+
	" the\nmangled corpse of a large snake in its talons. The top of the shield "+
	"is\nstraight and the sides of the shield curve from the corners "+
	"at the top\ndown towards the bottom where they come to a point. At the point "+
	"there is\na large gem. It appears to be an orange amber.\n",
	"gem","Which gem? The amber or the topaz?\n",
	"amber","This large, orange amber on the shield is polished to a shine and is "+
	"still\nfairly transparent. It is perfectly round and in the center you can "+
	"see what\nlooks like a spider wrapping a recently captured victim in a web.\n",
	"topaz","The large, polished topaz on the pommel of the sword sparkles with "+
	"an inner\nlight. As you look into the gem you start to feel yourself pulled "+
	"into it...\n\n\n    ...You shake your head vigourously. You felt as if your "+
	"soul were being\npulled into the gem. Knowing the capacity of the gem without"+
	" a wielder, you\nwonder what kind of power it has in the hands of a capable "+
	"user.\n",
	"sword","This ceremonial sword matches the shield which lies on top of it. "+
	"The hilt\nitself is fashioned from silver to resemble a pair of eagles "+
	"wings. The\npommel of the sword is a large sphere of a gem. It appears to be "+
	"a large\norange topaz. It has been polished and is perfectly smooth. The "+
	"point\nof the sword shows itself past the bottom of the shield and you can "+
	"see the\nvery end of the blood groove about four inches from the tip.\n",
	"heads","The heads of the demons on the table look to be perfect replicas "+
	"of the faces\non the walls. They are perfect enough that no human artisan "+
	"could have\ncarved them without magical aid. They leerat you from their "+
	"places\naround the sides of the stone table as if challenging your sanity.\n",
	"corpse","The corpse on the table has a crested shield and sword on its chest "+
	"that appear\nto have lain there for centuries. The corpse itself "+
	"however looks not more than\na few decades old. The bone structure itself "+
	"suggests that the person died at\na young age. You look closer at the face "+
	"and it looks like someone you may know\nfrom somewhere. "+
	"You have seen him recently, you could swear that you've talked\n"+
	"to someone that looked just like this person may have looked just a few "+
	"\nmoments ago.\n",
      }));
    set_smell("The smell of dust, age and death fill the air.\n");
    set_listen("You can almost hear the dust falling to the floor. "+
      "It is deathly quiet\nin here.\n");
} /* end of reset */

time_set(int len){
    call_out("say_it",(int)len);
    return 1;
} /* end of time_set */
say_it(){
    tell_room("players/relgar/workroom","It's time.\n");
    return; }
