inherit "inherit/monster";

reset(arg) {
  ::reset(arg);
  if(arg) return;

  set_name("aleena");
  set_gender(2);
  set_short("Aleena, the Chosen Prophet of the All-God");
  set_long(
	"Aleena is here to guide those in need, and aid the sick and dying.\n"+
	"Her power is great as she is the All-God's chosen one.\n");
  set_level(25);
  set_hp(2400);
  set_ac(26);
  set_wc(30);
  load_chat(5, ({ "Aleena asks: Do you seek the power of the All-God?\n",
	"Aleena asks: Do you seek wisdom, my child?\n",
	"Aleena says: Come worship with me child.\n"
  }));
  load_a_chat(5, ({ "Aleena calls to the All-God for aid.\n",
	"Aleena says: I am sorry to do this to you.\n",
	"Aleena says: You will feel the wrath of the Almighty One.\n"
  }));
}

init() {
  ::init();
  add_action("worship", "worship");
  welcome();
}

welcome() {
    write("Aleena says: Welcome, my child.\n"+
	  "Aleena says: Come and worship with me.\n");
  }

worship() {
  if(this_player()->query_ghost()) {
    write("Aleena says: By the power of the All-God I shall raise you!\n");
    this_player()->toggle_ghost();
    this_player()->heal_self(random(20));  /* nice service */
    return 1;
  }

  write("Aleena says: I can offer you the following services...\n\n"+

" Cure Disease...............100 gold coins.     \n"+
" Cure Wounds................100 gold coins.     \n"+

"\nAleena says: What healing can I aid you with?   \n"+
" Enter spell name (Return for none) > ");

input_to("worship2");
return 1;
}

worship2(string str) {
  string tmp1, tmp2;
  if(sscanf(str, "%sdisease%s", tmp1, tmp2))
    cure_disease();
  else if(sscanf(str, "%swounds%s", tmp1, tmp2))
    cure_wounds();
  else if(sscanf(str, "%srestoration%s", tmp1, tmp2))
    restoration();
  return 1;
}

  
cure_wounds() {
  if(healing_sphere_points < 2) {
    write("Aleena says: I am truely sorry, "+ this_player()->query_name() +
    ", but my powers are all spent.\nCome back when I am rested.\n");
    return 1;
  }
  if(this_player()->query_money() < 100) {
    write("Aleena says: I cannot pray for you if you cannot make the "+
    "correct donation.\n");
    return 1;
  }
  command("cw "+ lower_case(this_player()->query_name()), this_object());
  this_player()->add_money(-100);
  return 1;
}

cure_disease() {
  if(healing_sphere_points < 7) {
    write("Aleena says: I am truely sorry, "+ this_player()->query_name() +
    ", but my powers are all spent.\nCome back when I am rested.\n");
    return 1;
  }
  if(this_player()->query_money() < 200) {
    write("Aleena says: I cannot pray for you if you cannot make the "+
    "correct donation.\n");
    return 1;
  }
  command("cdis "+ lower_case(this_player()->query_name()), this_object());
  this_player()->add_money(-200);
  return 1;
}

