#include <mudlib.h>
#define MAX_GUARD	5
inherit ROOM;

object obj1, obj2;
int i;			/* counter for guards attacking */
void reset(status arg) {

  if(!find_living("cinthia")) {
    obj1 = clone_object(MONSTER);
    obj1 -> set_name("cinthia");
    obj1 -> set_alias("girl");
    obj1 -> set_alt_name("peasant");
    obj1 -> set_level(4);
    obj1 -> set_short("Cinthia the peasant girl");
    obj1 -> set_long(
          "Cinthia is a kindly, young peasant girl who sweeps the \n"+
          "pathways of market street. She has honey-golden hair   \n"+
          "and the prettiest of smiles. She is the favourite citizen\n"+
          "of Earothas and the city guard. No one would dare beat   \n"+
          "her up or attack her!\n");
    obj1 -> set_hp(80);
    obj1 -> add_class("cleric");
    obj1 -> load_spells(20,({ "cure light wounds", }));
    obj1 -> set_wc(8);
    obj1 -> set_ac(4);
    obj1 -> set_race("human");
    obj1 -> set_gender(2);
    obj1 -> set_al(1000);
    obj1 -> load_chat(15,({ "Cinthia sweeps the street.\n",
          "Cinthia smiles sweetly.\n",
          "Cinthia says: Hullo stranger.\n",
          "Cinthia smiles happily.\n",
          "Cinthia smiles cutely.\n",
          "Cinthia cleans the street.\n",
          "Cinthia smiles at you.\n",
    }));
    obj1 -> load_a_chat(15,({ "Cinthia cries.\n",
          "Cinthia bursts out into tears.\n",
          "Cinthia screams.\n",
          "Cinthia exclaims: Leave me alone!\n",
          "Cinthia shouts: Help guards!\n",
          "Cinthia shouts: Help! Earothas, help me!\n",
    }));
    obj1 -> set_heart_ob(this_object());
    obj1 -> set_wander(50,900);
    obj1 -> add_money(20);
    move_object(obj1, this_object());
  }
  if(!present("broom", find_living("cinthia"))) {
    obj2 = clone_object(TREASURE);
    obj2 -> set_name("broom");
    obj2 -> set_short("A wooden broom");
    obj2 -> set_long(
          "A wooden broom with a straw bottom. It looks well used.\n");
    obj2 -> set_value(10);
    obj2 -> set_sell_destruct(1);
    move_object(obj2, find_living("cinthia"));
  }
    
  if(arg) return;

  set_short("Market Street");
  set_long(
     "\tMarket Street\n"+
     "The street here is a mess with the last night's drinkers, spoiling\n"+
     "and staining the fine workmanship of the cobblestones. There is   \n"+
     "even beer on the walls of the city gardens to the southwest.\n");
  set_items(({
     "beer#vomit#mess",
          "A mess of vomit and beer",
     "cobblestones",
          "The fine cobblestones of dwarvish design are a mess with \n"+
          "a night of revalry of the local inhabitants of Tempus city",
     "walls#wall",
          "The walls of the city gardens",
  }));
  set_weather(1,1,0);
  set_exits(({
     "room/city/market2",   "north",
     "room/city/market4",   "south",
  }));
}


void monster_heart_beat() {
  object mon;

  if(find_living("cinthia")->query_attack() && !present("guard")) {
    if(i > MAX_GUARD) return;
    mon = clone_object("room/city/monst/guard1");
    move_object(mon, environment(find_living("cinthia")));
    mon -> add_secondary_attacker(find_living("cinthia")->query_attack());

    tell_room(environment(find_living("cinthia")),
     "\n\nCinthia shouts: Guards! Guards! Guards!\n"+
     "Guard arrives.\n"+
    "Guard exclaims: Unhand her, you bandit! I'll report you to Earothas!\n\n");
    i++;
  }
}
