#include <mudlib.h>
inherit ROOM;

void reset(status arg) {
  if(!present("board")) {
    object board;
    board = clone_object(BULLETIN_BOARD);
    board -> set_save_file("ob_saves/square_board");
    board -> set_long(
            "This board is used to post notices on general mud happenings.\n");
    move_object(board, this_object());
  }
  if(arg) return;

  set_no_fight(1);
  set_short("The city square of Tempus");
  set_long(
     "A small garden of flowers surrounds a small clearing that marks \n"+
     "the city square of the city Tempus. The town hall stands in all\n"+
     "its majesty to the north, across a small wooden bridge. In the \n"+
     "center of the clearing here is a tall bell tower. To the south  \n"+
     "are the city gardens. ");

  set_night_desc(
     "Tall bronzed torch stands shed light \ninto the square. ");
 /* note that the bulletin board makes a new line */
  set_night_items(({
     "torch#stands#torch stands",
     "Flaming torches shed light into the square",
     "flame#fire#flames",  "It looks like the torch is on fire"
  }));

  set_items(({

     "town hall#hall", "The great town hall of Tempus city",
     "bridge", "A solid wooden bridge that spans a small lake",
     "lake", "It is too far away to see from here",

     "tower#bell#bell tower",
     "Atop the bell tower is a large brass bell. Although it \n"+
     "looks quite old, it appears to still be well used",

     "gardens", "The beautiful city gardens of Tempus City",
     "garden", "A garden of beautiful flowers",
     "flower#flowers",
               "There are roses here in full bloom",
     "rose#roses",  "They are the most beautiful you have ever seen"
  }));

  set_smell("All about you smell beautiful roses\n");
 
  set_weather(2, 4, 0);
  set_exits(({
   "room/city/bridge",        "north",
   "room/city/garden/n_gate", "south",
  "room/city/main_st1",       "east",
  "room/city/dark_rd1",       "west",
  }));
}

void init() {
  ::init();
  add_action("ring1", "ring");
}

status ring1(string str) {
  if(str == "bell") {
    if(!query_day()) {
      write("You don't want to wake all the citizens do you?\n");
      return 1;
    }
    write("You ring the bell.\n");
    say(this_player()->query_name()+" rings the square bell.\n",
          this_player());
    call_out("ring2", 1);
    return 1;
  }
}

void ring2() {
  this_player()->check_shout("The city bell rings clearly throughout "+
  "the realms...\n");
  return;
}

int query_prop(string str) {
  if(str == "Nulmagic") return 1;
  return 0;
}

int query_property(string str) {
  return query_prop(str);
}
